SystemOrganization addCategory: #'Nagare-Squeak-Core'!

NgPortableUtil subclass: #NgSqPortableUtil
	instanceVariableNames: 'socketStream udpSocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Nagare-Squeak-Core'!

!NgSqPortableUtil class methodsFor: 'shutdown' stamp: 'mu 5/2/2012 16:10'!
shutDown: quitting
	quitting ifTrue: [self release].! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/4/2012 12:36'!
ensuredSocketStream
	self socketStream isNil
		ifTrue: [self prepareSocketStream]
		ifFalse: [self socketStream isConnected
				ifFalse: [self releaseSocketStream; prepareSocketStream]].
	^ self socketStream! !

!NgSqPortableUtil methodsFor: 'private' stamp: 'MasashiUmezawa 6/9/2016 19:23'!
heartbeatTo: host port: port
	self udpSocket sendData: '' toHost: (NetNameResolver addressForName: host) port: port! !

!NgSqPortableUtil methodsFor: 'shutdown' stamp: 'mu 5/2/2012 14:00'!
listenSystemShutdownEvent
	SmalltalkImage current addToShutDownList: self class! !

!NgSqPortableUtil methodsFor: 'private' stamp: 'mu 5/2/2012 14:37'!
prepareSocketStream
	| str |
	str := SocketStream openConnectionToHostNamed: self settings host port: self settings port.
	
	self socketStream: str! !

!NgSqPortableUtil methodsFor: 'initialize-release' stamp: 'mu 5/2/2012 14:48'!
release
	self releaseSocketStream.
	super release
	! !

!NgSqPortableUtil methodsFor: 'private' stamp: 'mu 5/4/2012 20:31'!
releaseHeartbeatProcess
	super releaseHeartbeatProcess.
	udpSocket
		ifNotNil: 
			[udpSocket destroy.
			udpSocket := nil]! !

!NgSqPortableUtil methodsFor: 'private' stamp: 'mu 5/2/2012 14:38'!
releaseSocketStream
	self socketStream ifNil: [^self].
	self socketStream close.
	self socketStream: nil! !

!NgSqPortableUtil methodsFor: 'sending' stamp: 'mu 5/2/2012 23:59'!
sendBytes: bytes
	[self ensuredSocketStream nextPutAllFlush: bytes] on: NetworkError do: [:ex |
		(NgNetworkError originalError: ex) signal
	]! !

!NgSqPortableUtil methodsFor: 'converting' stamp: 'mu 5/2/2012 17:06'!
shortStackStringFrom: anException 
	| ctx stackString |
	ctx := anException signalerContext.
	stackString := ctx isNil
				ifTrue: ['']
				ifFalse: [String
						streamContents: [:strm | (ctx stackOfSize: 20)
								do: [:item | strm print: item. strm nextPutAll: '\'. 
										 ]]].
	^ stackString! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 14:13'!
socketStream
	"Answer the value of socketStream"

	^ socketStream! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/2/2012 14:13'!
socketStream: anObject
	"Set the value of socketStream"

	socketStream := anObject! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/4/2012 17:46'!
udpSocket

	^udpSocket ifNil: [udpSocket := Socket newUDP]! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'mu 5/4/2012 17:46'!
udpSocket: anObject
	"Set the value of udpSocket"

	udpSocket := anObject! !

!NgSqPortableUtil methodsFor: 'accessing' stamp: 'MasashiUmezawa 6/6/2015 23:26'!
unixTimeSeconds
	^ DateAndTime current asUnixTime! !
